@import '../../styles/variables';
@import '../../styles/mixins';

$-cui-radio-transition-duration: .3s;
$-cui-radio-label-margin: .5rem;

form {
  > .cui-radio-group {
    display: block;
    margin-bottom: $cui-form-field-margin-bottom;
  }
  > .cui-radio-button,
  > .cui-radio-group .cui-radio-button {
    display: flex;
    margin-bottom: $cui-form-field-margin-bottom * 0.5;
    margin-right: 0;
  }
}

.cui-radio-button {
  display: inline-flex;
  margin-right: $cui-form-field-margin-bottom;

  &.cui-radio-spread {
    display: flex;
    margin-bottom: $cui-form-field-margin-bottom * 0.5;
    margin-right: 0;
  }

  &:last-child {
    margin-right: 0;
  }

  .cui-radio-container {
    display: inline-flex;
    position: relative;
    flex-shrink: 0;
  }

  .cui-radio-outer-circle,
  .cui-radio-inner-circle {
    display: block;
    height: 100%;
    width: 100%;
    border-radius: 50%;
    position: absolute;
    top: 0;
    left: 0;
  }

  .cui-radio-outer-circle {
    transition: background-color ease $-cui-radio-transition-duration,
                box-shadow $cui-focus-transition;
  }

  .cui-radio-inner-circle {
    opacity: 0;
    transform: scale(0.001);
    transition: transform ease $-cui-radio-transition-duration,
                opacity ease $-cui-radio-transition-duration,
                background-color ease $-cui-radio-transition-duration;
  }

  label {
    @include cui-no-select();
    flex: 1 1 auto;
    display: inline-flex;
    cursor: pointer;
  }

  .cui-radio-label {
    @include cui-select();
    @include cui-break-word();
  }

  // ----- align

  .cui-radio-labeled {
    margin-left: $-cui-radio-label-margin;
  }

  .cui-radio-right {
    flex-direction: row-reverse;

    .cui-radio-labeled {
      margin-left: 0;
      margin-right: $-cui-radio-label-margin;
      text-align: right;
    }
  }

  .cui-radio-left-spread {
    justify-content: space-between;
  }

  .cui-radio-right-spread {
    flex-direction: row-reverse;
    justify-content: space-between;

    .cui-radio-labeled {
      margin-left: 0;
      margin-right: $-cui-radio-label-margin;
    }
  }

  // ----- states

  &.cui-radio-disabled label {
    cursor: not-allowed;
    opacity: $cui-disabled-opacity;
  }

  &.cdk-program-focused,
  &.cdk-keyboard-focused {
    .cui-radio-outer-circle {
      box-shadow: 0 0 0 2px $cui-focus-color;
    }
  }

  &.cui-radio-checked {
    .cui-radio-outer-circle {
      background-color: cui-color(primary, bg);
      border: 1px solid cui-color(primary, bg);
    }
    .cui-radio-inner-circle {
      background-color: cui-color(primary, fill);
      transform: scale(0.375);
      opacity: 1;
    }
    &:not(.cui-radio-disabled) label:hover .cui-radio-outer-circle {
      background-color: cui-color(primary, bg-hover);
      border-color: cui-color(primary, bg-hover);
    }
    &:not(.cui-radio-disabled) label:hover .cui-radio-inner-circle {
      background-color: cui-color(primary, fill-hover);
    }
    &:not(.cui-radio-disabled) label:active .cui-radio-outer-circle {
      background-color: cui-color(primary, bg-active);
      border-color: cui-color(primary, bg-active);
    }
    &:not(.cui-radio-disabled) label:active .cui-radio-inner-circle {
      background-color: cui-color(primary, fill-active);
    }
  }

  // ----- mode

  @mixin mode($mode) {
    &[data-cui-mode='#{$mode}'] {
      &:not(.cui-radio-checked) {
        .cui-radio-outer-circle {
          background-color: cui-color($mode, input-background);
          border: 1px solid cui-color($mode, input-border);
        }
        &:not(.cui-radio-disabled) label:hover .cui-radio-outer-circle {
          background-color: cui-color($mode, input-background-hover);
          border-color: cui-color($mode, input-border-hover);
        }
      }
    }
  }

  @include mode('primary');
  @include mode('secondary');

  // ----- sizes

  @mixin size($size) {
    &[data-cui-size="#{$size}"] {
      .cui-radio-container {
        width: cui-height($size) * 0.5;
        height: cui-height($size) * 0.5;
      }
      .cui-radio-label {
        @include cui-text($size);
      }
    }
  }

  @include size('s');
  @include size('m');
  @include size('l');
}
